module Postfix::Rate::Models
  class AuthenticatedIdentity < Sequel::Model
    include Tracking

    many_to_one :policy
    many_to_one :tracker

    plugin :association_dependencies, tracker: :destroy

    def label
      "authenticated user '#{identity}'"
    end

    def self.default_policy_name
      'default_for_identities'
    end

  end
end