module Postfix::Rate::Models
  class Tracker < Sequel::Model
    plugin :serialization, :yaml, :heuristics
    plugin :serialization_modification_detection

    def before_create
      self.first_seen = Time.now
      self.last_update = Time.now
    end

    def reset!
      self.count = 0 unless count.blank?
      self.recipients = 0 unless recipients.blank?
      self.volume = 0 unless volume.blank?
      self.last_update = Time.now
      save
    end

  end
end