require "postfix/rate/models/policy"
require "active_support/concern"

module Postfix::Rate::Models
  module Tracking

    TOP_SENDERS_THRESH = 0.95

    extend ActiveSupport::Concern

    included do

    end

    def before_create
      self.policy  = Policy.find(name: self.class.default_policy_name) unless policy
      self.tracker = Tracker.create unless tracker
      super
    end


    def disable!(reason)
      self.disabled = true
      self.disable_date = Time.now
      self.disable_reason = reason
      save_changes
    end


    def reset_tracker!
      tracker.reset!
    end

    module ClassMethods

      def top_senders(limit = TOP_SENDERS_THRESH)
        thresh = '((trackers.count * 1.0 / policies.count) > ?) or
                  ((trackers.volume * 1.0 / policies.volume) > ?) or
                  ((trackers.recipients * 1.0 / policies.recipients) > ?)'

        select_all(:"#{table_name}").join_table(:inner, :policies, id: :policy_id).join_table(:inner, :trackers, id:  :"#{table_name}__tracker_id").where(thresh, limit, limit, limit).order_by('trackers.count DESC')
      end
    end
  end
end